image: docker:latest
services:
  - docker:dind

stages:
  - build
  - release
  - deploy

variables:
  CONTAINER_LATEST_IMAGE: $CI_REGISTRY_IMAGE:latest
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

build:
  stage: build
  only:
    - master
  script:
    - docker build --build-arg CLIENT_SENTRY_DSN_URL=$CLIENT_SENTRY_DSN_URL --build-arg SERVER_SENTRY_DSN_URL=$SERVER_SENTRY_DSN_URL --pull -t $CONTAINER_TEST_IMAGE -f ./app/Dockerfile ./app
    - docker push $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_LATEST_IMAGE
    - docker push $CONTAINER_LATEST_IMAGE

release-image:
  stage: release
  only:
    - tags
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE

deploy:
  stage: deploy
  only:
    - tags
  script:
    - apk add curl
    - curl -H "Authorization:Bearer $NATADECOCO_APP_TOKEN" -H "Content-Type:application/json" -d "{\"image\":\"$CONTAINER_RELEASE_IMAGE\"}" $NATADECOCO_HOOK_URL
